const webpack = require('webpack');
const path = require('path');
const GitRevisionPlugin = require('git-revision-webpack-plugin')
const paths = require('./config/paths');
const pkg = require(paths.appPackageJson);

module.exports = function override(config, env) {
  let c = config;

  const {
    CMP_API_GATEWAY = '',
    CMP_API_PATH = '/api',
    CMP_DASHBOARD = 'http://mcp-d-multi-cloud-platform.ipaas.enncloud.cn',
    CMP_PROFILE = /* replacement */'demo1'/* replacement */,
    CMP_LOGGER = 'OFF', // ON: show redux log in console ( only work in development )
    CMP_LOGGER_DIFF = 'OFF', // ON: show state diff
    CMP_AWCLOUD_HOST = 'http://172.21.65.205/',
    CMP_AWCLOUD_USERNAME = 'admin',
    CMP_AWCLOUD_PASSWORD = '1qaz@WSX',
    CMP_MONITOR_ALARM = 'ON',
    CMP_FT_REGISTER = 'ON',
    CMP_AUDIT_ABLE = 'ON',
    TR_TITLE ='云运营管理平台',
    TR_NAV_TITLE='运营管理平台',
    TR_WELCOME01 = '欢迎使用云服务交付平台',
    TR_WELCOME02 = '混合管理，一体交付',
    NODE_ENV,
  } = process.env

  const gitRevisionPlugin = new GitRevisionPlugin();

  /*
  const plugin = new webpack.DefinePlugin({
    __PROFILE__: JSON.stringify(CMP_PROFILE),
    __API_GATEWAY__: JSON.stringify(CMP_API_GATEWAY),
    __API_PATH__: JSON.stringify(CMP_API_PATH),
    __API_DASHBOARD__: JSON.stringify(CMP_DASHBOARD),
    __NODE_ENV__: JSON.stringify(NODE_ENV),
    __LOGGER__: JSON.stringify(CMP_LOGGER),
    __LOGGER_DIFF__: JSON.stringify(CMP_LOGGER_DIFF),
    __CMP_AWCLOUD_HOST__: JSON.stringify(CMP_AWCLOUD_HOST),
    __AWCLOUD_USERNAME__: JSON.stringify(CMP_AWCLOUD_USERNAME),
    __AWCLOUD_PASSWORD__: JSON.stringify(CMP_AWCLOUD_PASSWORD),
    __FT_REGISTER__: JSON.stringify(CMP_FT_REGISTER),
    __AUDIT_ABLE__: JSON.stringify(CMP_AUDIT_ABLE),
    __VERSION__: JSON.stringify(gitRevisionPlugin.version()),
    __COMMITHASH__: JSON.stringify(gitRevisionPlugin.commithash()),
    __BRANCH__: JSON.stringify(gitRevisionPlugin.branch()),
    __NAME__: JSON.stringify(pkg.name),
    __MONITOR_ALARM__: JSON.stringify(CMP_MONITOR_ALARM),
  });

  c.plugins.push(plugin);
  */
  c.devtool = 'cheap-eval-source-map';

  // Update Title
  c.plugins
    .filter(({ options: { title } = {} }) => title)
    .map(p => {
      p.options = {
        ...p.options,
        title: TR_TITLE,
        transations: {
          TITLE: TR_TITLE,
          NAV_TITLE: TR_NAV_TITLE,
          WELCOME01: TR_WELCOME01,
          WELCOME02: TR_WELCOME02,
        },
      };
    });

  return c;
};
